;space invaders in 512 bytes for the ZX Spectrum 48/128
;author - Poxoft/uZeroNiq, final version 19.6.2012
;assembler editor and compiler - ZX Spin for Windows
;no lives, no death, invaders dont attack :-)


MAIN		org 40963

;run 41048
;movret - datatransfer subroutine return / 2048x LDI

movret		ret

;40964 - gfxinv, mature, rocket - gfx data

gfxinv		defb 255,60,126,219,255,153,165,36
mature		defb 128,225,135,99,70,39,36,8,16
		defb 255,255,150,245,191,236,228,149
		defb 128,255,255,255,117,126,170,0,0
		defb 255,255,195,67,135,161,15,80
rocket		defb 80,0,128,0,128,15,248,63,254
		defb 65,193,93,221,93,221,28,156

;positions, memory as highbyte, left and right scroll cords

pohyby		defb 16,136,1,30
		defb 88,136,65,94
		defb 32,136,129,158
		defb 72,136,193,222
		defb 84,128,97,126
		defb 84,128,129,158

;default rocket position - center

pozicerck	defb 128

;main start, clear screen, clear allocation memory, sound effect
		
		ld de,32772
		ld a,d
delp		ld hl,11264
		ld c,h
delx		ld b,l
dely		sla (hl)
		inc hl
		djnz dely
		push af
zvukloop2	dec a
		out (254),a
		jr nz,zvukloop2
		pop af
		dec c
		jr nz,delx
		dec a
		jr nz,delp

deldata		ld h,d
		ld b,16
		ldir

;create 24 invaders to backmemory

start		ld d,160
		ld b,e
		ld l,e
schov1		push bc
		ld c,6
schov2		ld h,136	;34816
		push de
		ld b,8
schov3		ld a,(de)
		ld (hl),a
		inc h
		inc e
		djnz schov3
		pop de
		ld a,e
		add a,l
		ld l,a
		dec c
		jr nz,schov2
		ld a,41
		add a,l
		ld l,a
		pop bc
		djnz schov1

;create 4kB superfast datatransfer - start address 36864
;alternative for LDIR, max. 2048 bytes, very fast
;need only HL and DE register, BC = select call address :-)

		ld l,b
ldirloop	ld (hl),237
		inc hl
		ld (hl),d
		inc hl
		djnz ldirloop
		dec a
		jr nz,ldirloop

;create mature to backmemory, create player to screen
	
raketa		ld l,111	
rok1		ld b,3
		set 3,e
schor2		ld a,(de)
		ld h,a
		inc e
		ld c,8
schor3		ld a,(de)
		ld (hl),a
		inc e
		inc l
		ld a,(de)
		ld (hl),a
		dec l
		inc h
		inc e
		dec c
		jr nz,schor3
		ld a,32
		add a,l
		ld l,a
		djnz schor2

	
;create copy of position and cords table for next run

schovpohyby	ex de,hl
		ld d,a
		call 40574

;create screen colors, DE must be defined :-(

bilyink		ld h,88
		ld a,7
		ld (hl),a
		ld de,22529
		call 39424

;objects color

obarvi1		dec h
obar1		ld b,64
obar2		dec hl
		ld (hl),a
		djnz obar2
		dec a
		jr nz,obar1


;create firecheck position on screen address-table

tablefire	ld hl,53289
		ld de,832
fire2		ld b,8
		xor a
fire3		ld (hl),a
		dec l
		ld (hl),e
		dec l
		add a,32
		djnz fire3
		ld a,e
		add a,8
		ld e,a
		dec d
		jr nz,fire2

;create right scroll routine and modify

modifrun	ld hl,41454
		ld de,41475
		call 40902
		ld (hl),30
		inc l
		dec (hl)

;start of main loop
;scroll all objects in backmemory

pohyb1		ld hl,53199
		ld b,6
semtam		push bc
		ld a,(hl)	
		dec a	
		jr nz, zapis1
		ld a,112	;max. interval
zapis1		ld (hl),a
		inc l
		ld d,(hl)
		inc l
		ld e,(hl)
		inc l
		cp 57		;left or right ???
		jr nc,vpravo1
		ld e,(hl)
		ex de,hl
		call lcal1
		jr hotovo1
vpravo1		ex de,hl
		call 41476	;scroll to the right
hotovo1		ex de,hl
		inc l
		pop bc
semdo		djnz semtam

		push hl

;		ld hl,16479
;		call lcal1

;now is right time for transfer invaders on screen
;some transfer in next frame, all scrollers are OK

		ld hl,34816
		ld de,18432
		call 36864

;fucking space universe with scroll

;		ld h,64
;		ld d,h
;		ld a,r
;stars		ld l,a
;		cp h
;		jr c,kuk
;		ld e,h
;kuk		ld (hl),e
;		call lcal1

;now is righttime for transfer mature on screen
;more bytes, but fast

maturven	ld h,128
	ld d,64
		ld a,8
mmhlde		ld l,96
		ld e,160
		call 40768
		inc h
		dec a
		jr nz,mmhlde

;		halt

;short clear of bottom screen, e=0, l=0

		ld b,160	
smazto		ld c,8
		ld d,80	
smao2		ld (de),a
		inc d		
		dec c			
		jr nz,smao2
		inc e
		djnz smazto


;check and provide firebomb

fireon		ld h,209	;53696
		cp (hl)
		jr z,nicsened


;if byte is empty = non-exist firebomb, go to test keyboard

		ld b,(hl)	;firebyte
		inc l
		ld e,(hl)	;fire-time position
		inc l		;where read from table fire
		ld a,(hl)	;where is firebomb???

fireoff		cp 32		;is firebomb on the top?
		jr z,nicsened

		inc (hl)
		inc (hl)	;plus 2 for next position
		ld l,a
		dec h		;read from table fire
		ld d,(hl)
		inc l
		ld a,(hl)
		add a,e		;position for write on screen
		ld e,a

		xor a
zvukloop	dec a
		out (254),a
		jr nz,zvukloop
		xor a

		ld a,b		;in reg.A firebomb byte
naraz		ex de,hl
		ld c,(hl)	;read
		and c		;combination
		jr nz, narazb	;check
strelb		ld a,b

strela		ld b,8		;RELEASE firebomb
kresli		ld (hl),a	;nasere to lajnu na obrazovku
		inc h
		djnz kresli
		
		cp b		;is this mature?
		jr nz, nicsened	;naky hovno

fxsound		ld h, 12
fx1		ld b,h     
fx		push bc
		set 4,a
		out (254),a
		ld b, (hl) 
fx2		djnz fx2
		res 4,a
		out (254),a
		dec hl
fx3		djnz fx3
		pop bc
		djnz fx1         
		
		pop hl
		jp 41048	;game restart

narazb		ld a,(53698)	;read position
		cp 30		;check
		jr nz,nenimatu	;collision?
		xor a
		jr strela
nenimatu		dec a
		out (254),a
		jr nz,nenimatu
		ld b,8
		ld h,136
booom		dec l
		ld (hl),a
		inc l
		ld (hl),a
		inc l
		ld (hl),a
		dec l
		inc h
		djnz booom
		
vedle		ld (53696),a	
nicsened	pop hl


;remote routine, O for left, P for right, E for fire

rckremote	ld a,(23556)
		cp 79
		jr nz,xx1
raketleft	ld a,(hl)
		cp 24		;left cord
		call nz,lcalu	;;scrool to the left
xx1		cp 80
		jr nz,xx2
raketright	ld a,(hl)
		cp 232		;right cord
		call nz,41472	;scrool to the right
xx2		cp 69		;fire!
		jr nz,poakci

;fire init

strilej		ld a,(hl)
		srl a
		srl a
		srl a
		ld b,a		;bylo E
		add a,160
		ld l,a
		ld h,80
		ld c,(hl)	;fire byte
		ld (53696),bc	;fire position
		xor a
		ld (53698),a	;weapon ready

poakci		halt
poakci2		jp pohyb1	;end of main loop


     		org 41451

;left-scroll subroutine, must be from 41451

lcalu		dec (hl)
lcal0		ld hl,20669
lcal1		xor a		;antioverflow
		ld c,8
lefm		ld b,32
		push hl	
lef1		rl (hl)
		dec l
		djnz lef1
		pop hl
		inc h
		dec c
		jr nz,lefm
		ret

;right-scroll subroutine
;copy of left-scroll routine from address lcal0+2

modif		defb 52		;instr. inc (hl)
		defb 33,161	;instr. ld hl,...


;end of code - total 512 bytes!
;kurva, ja se snad ten strojak fakt naucim
;co cumis, vole ??? :-)
;tady uz nic neni
;no fakt, to je cely

